﻿namespace HeuristicLab.BenchmarkSuite.ProblemData {
  using HeuristicLab.Algorithms.PushGP.Interpreter;

  public class GradePushData : Data<long[], string>, IPushData {
    public GradePushData(Example<long[], string>[] training, Example<long[], string>[] test)
      : base(training, test, 0, 5) {
    }

    public void ApplyTrainingInput(IPushGpInterpreter interpreter, int index) {
      interpreter.IntegerStack.Push(this.Training[index].Input);
    }

    public void ApplyTestInput(IPushGpInterpreter interpreter, int index) {
      interpreter.IntegerStack.Push(this.Test[index].Input);
    }

    public double CompareTrainingOutput(IPushGpInterpreter interpreter, int index) {
      return this.CompareOutput(
        interpreter.IntegerStack,
        index,
        this.Training,
        data => GetAsciiResultDifference(data, interpreter.IntegerStack));
    }

    public double CompareTestOutput(IPushGpInterpreter interpreter, int index) {
      return this.CompareOutput(
        interpreter.IntegerStack,
        index,
        this.Training,
        data => GetAsciiResultDifference(data, interpreter.IntegerStack));
    }
  }
}
