﻿namespace HeuristicLab.BenchmarkSuite.ProblemData {

  using HeuristicLab.Algorithms.PushGP.Interpreter;

  public class NumberIoPushData : Data<double[], double>, IPushData {
    public NumberIoPushData(Example<double[], double>[] training, Example<double[], double>[] test)
      : base(training, test, 0, 200) {
    }

    public void ApplyTrainingInput(IPushGpInterpreter interpreter, int index) {
      interpreter.FloatStack.Push(Training[index].Input[0]);
      interpreter.IntegerStack.Push((long)Training[index].Input[1]);
    }

    public void ApplyTestInput(IPushGpInterpreter interpreter, int index) {
      interpreter.FloatStack.Push(Test[index].Input[0]);
      interpreter.IntegerStack.Push((long)Test[index].Input[1]);
    }

    public double CompareTrainingOutput(IPushGpInterpreter interpreter, int index) {
      return this.CompareOutput(
        interpreter.FloatStack,
        index,
        this.Training,
        data => GetFloatResultDifference(data, interpreter.FloatStack));
    }

    public double CompareTestOutput(IPushGpInterpreter interpreter, int index) {
      return this.CompareOutput(
        interpreter.FloatStack,
        index,
        this.Test,
        data => GetFloatResultDifference(data, interpreter.FloatStack));
    }
  }
}
